diff --git a/gdb/infcmd.c b/gdb/infcmd.c
index 103899432f7..3e7fdb374a4 100644
--- a/gdb/infcmd.c
+++ b/gdb/infcmd.c
@@ -1079,7 +1079,19 @@ jump_command (const char *arg, int from_tty)
   std::vector<symtab_and_line> sals
     = decode_line_with_last_displayed (arg, DECODE_LINE_FUNFIRSTLINE);
   if (sals.size () != 1)
-    error (_("Unreasonable jump request"));
+    {
+      /* If multiple sal-objects were found, try dropping those that aren't
+	 from the current symtab.  */
+      sals.erase (std::remove_if (sals.begin (), sals.end (),
+		  [] (symtab_and_line &sal)
+		    {
+		      struct symtab_and_line cursal
+			  = get_current_source_symtab_and_line ();
+		      return sal.symtab != cursal.symtab;
+		    }), sals.end ());
+      if (sals.size () != 1)
+	error (_("Unreasonable jump request"));
+    }
 
   symtab_and_line &sal = sals[0];
 
diff --git a/gdb/testsuite/gdb.base/jump_multiple_objfiles.c b/gdb/testsuite/gdb.base/jump_multiple_objfiles.c
new file mode 100755
index 00000000000..b54eede9eb1
--- /dev/null
+++ b/gdb/testsuite/gdb.base/jump_multiple_objfiles.c
@@ -0,0 +1,30 @@
+/* This testcase is part of GDB, the GNU debugger.
+
+   Copyright 2021-2023 Free Software Foundation, Inc.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+#include "jump_multiple_objfiles.h"
+
+extern int foo (int n);
+
+
+int
+main ()
+{
+  int n = foo (1);
+  bar (n);
+
+  return 0;
+}
diff --git a/gdb/testsuite/gdb.base/jump_multiple_objfiles.exp b/gdb/testsuite/gdb.base/jump_multiple_objfiles.exp
new file mode 100755
index 00000000000..56bbc21c92e
--- /dev/null
+++ b/gdb/testsuite/gdb.base/jump_multiple_objfiles.exp
@@ -0,0 +1,57 @@
+#   Copyright 2021-2023 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+#
+# Tests GDBs support for jump, when the source line is in multiple
+# object files.
+
+
+standard_testfile .c
+set srcfile2 jump_multiple_objfiles_foo.c
+set srcfile3 jump_multiple_objfiles.h
+
+
+if { [prepare_for_testing "failed to prepare" $testfile \
+      [list ${srcfile} ${srcfile2}]] } {
+    return -1
+}
+
+if { ![runto_main] } {
+    perror "couldn't run to breakpoint"
+    return -1
+}
+
+
+set bar_first_line [gdb_get_line_number "bar-first-line" ${srcfile3}]
+set bar_middle_line [gdb_get_line_number "bar-middle-line" ${srcfile3}]
+set bar_last_line [gdb_get_line_number "bar-last-line" ${srcfile3}]
+
+
+# Set breakpoints in the function bar.  Executable has two object files,
+# and both have a copy of the same source lines.  Therefore breakpoints
+# will have two locations.
+gdb_breakpoint "${srcfile3}:${bar_first_line}"
+gdb_breakpoint "${srcfile3}:${bar_last_line}"
+
+# Run to the breakpoint in bar.
+gdb_continue_to_breakpoint "bar_first_line" \
+    ".*${srcfile3}:${bar_first_line}.*"
+
+# Jump within the function.  Debugger shall be able to jump, even if the
+# target line is in two different object files.  After jump, we will hit
+# the breakpoint at the last line of bar.
+gdb_test "jump ${bar_middle_line}"  [multi_line \
+    "Continuing at ($hex).*" \
+    "Breakpoint ${decimal}.* at .*${srcfile3}:${bar_last_line}.*"] \
+    "Jump within the objectfile"
diff --git a/gdb/testsuite/gdb.base/jump_multiple_objfiles.h b/gdb/testsuite/gdb.base/jump_multiple_objfiles.h
new file mode 100755
index 00000000000..0a3815e1808
--- /dev/null
+++ b/gdb/testsuite/gdb.base/jump_multiple_objfiles.h
@@ -0,0 +1,30 @@
+/* Copyright (C) 2021-2023 Free Software Foundation, Inc.
+
+   This file is part of GDB.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+#ifndef JUMP_MULTIPLE_OBJFILES_H
+#define JUMP_MULTIPLE_OBJFILES_H
+
+static int
+bar (int n)
+{
+  int retval = n;
+  retval += 1;      /* bar-first-line */
+  retval *= -1;     /* bar-middle-line */
+  return retval;    /* bar-last-line */
+}
+
+#endif /* JUMP_MULTIPLE_OBJFILES_H */
diff --git a/gdb/testsuite/gdb.base/jump_multiple_objfiles_foo.c b/gdb/testsuite/gdb.base/jump_multiple_objfiles_foo.c
new file mode 100755
index 00000000000..16863c8594b
--- /dev/null
+++ b/gdb/testsuite/gdb.base/jump_multiple_objfiles_foo.c
@@ -0,0 +1,24 @@
+/* This testcase is part of GDB, the GNU debugger.
+
+   Copyright 2021-2023 Free Software Foundation, Inc.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+#include "jump_multiple_objfiles.h"
+
+int
+foo (int n)
+{
+  return bar (n);
+}